﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using System.Diagnostics;

namespace UltraComboEditorMultiSelectItems
{
    public partial class Form1 : Form
    {
        private DataTable dt;
        public Form1()
        {
            InitializeComponent();


            dt = new DataTable();
            dt.Columns.Add("Check", typeof(bool));
            dt.Columns.Add("Item", typeof(string));

            dt.Rows.Add(false, "Item 1");
            dt.Rows.Add(false, "Item 2");
            dt.Rows.Add(false, "Item 3");
            dt.Rows.Add(false, "Item 4");
            dt.Rows.Add(false, "Item 5");


            ultraCombo1.DisplayMember = "Item";
            ultraCombo1.DataSource = dt;

            ultraCombo1.CheckedListSettings.EditorValueSource = EditorWithComboValueSource.CheckedItems;
            ultraCombo1.CheckedListSettings.CheckStateMember = "Check";
            ultraCombo1.CheckedListSettings.ItemCheckArea = Infragistics.Win.ItemCheckArea.Item;


            ultraCombo1.DisplayLayout.Bands[0].Columns["Check"].Header.CheckBoxVisibility = Infragistics.Win.UltraWinGrid.HeaderCheckBoxVisibility.Always;
        }

        private void ultraCombo1_ListChanged(object sender, ValueListChangedEventArgs e)
        {

            if (ultraCombo1.CheckedRows.Count == ultraCombo1.Rows.Count)
            {
                ultraCombo1.CreationFilter = new CreatingTextUIElement();
            }
            else
            {
                ultraCombo1.CreationFilter = null;
            }
        }
    }

    public class CreatingTextUIElement : IUIElementCreationFilter
    {

        public void AfterCreateChildElements(UIElement parent)
        {
            EditorWithTextUIElement El = parent as EditorWithTextUIElement;
            if (El != null && El.Parent.GetType() == typeof(EditorWithComboUIElement))
            {
                El.ChildElements.Clear();
                EditorWithTextDisplayTextUIElement textElement = new EditorWithTextDisplayTextUIElement(El, "All");
                textElement.Rect = new Rectangle(El.Rect.X, El.Rect.Y, El.Rect.Width, El.Rect.Height);
                El.ChildElements.Add(textElement);
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }
}
